import pymongo
import argh

def main(email_to_find: str,container_name:str = "overleafmongo", port: int = 27017) -> bool:
    print(f"User name: {email_to_find}" )
    client = pymongo.MongoClient(container_name, port)
    db = client.sharelatex
    users = db.users
    search_result = users.find_one({"email": email_to_find})

    if search_result is None:
        print("User not found")
        return
    else:
        print(f"User status was: {search_result['isAdmin']}")
        users.update_one(
            {"email": email_to_find},
            {"$set": {"isAdmin": True}}
        )
        print("User status changed")
        return

    client.close()


if __name__ == "__main__":
    argh.dispatch_command(main)
